private import SDL;
private import SDL_mixer;
private import tango.stdc.stringz;
private import tango.text.convert.Format;

final class Sound {
  private const Mix_Chunk* chunk;
  private int channel;

  this(char[] fileName) {
    chunk = Mix_LoadWAV(toStringz(fileName));
    if (chunk is null) {
      throw new Exception(Format("failed to load a sound from {}.", fileName));
    }
  }

  ~this() {
    Mix_FreeChunk(chunk);
  }

  void play() {
    channel = Mix_PlayChannel(-1, chunk, 0);
  }

  bool playing() {
    return Mix_Playing(channel) > 0;
  }
}